/*
 * userhost.c -- handles the /userhost and /ison commands.
 * This formally obsoletes whois.c
 * Written by Jeremy Nelson (C) 1995
 * Some of the stuff i took from whois.c
 * See the COPYRIGHT file or do /help ircII copyright
 */


/* the function must take a 1) nick/userhost info and 2) extra info */
typedef void (*uh_ison_func) _((char *, char *));

typedef struct __stuff_list {
	struct __stuff_list *	next;
	char *			stuff;
	char *			nicklist;
	uh_ison_func 		func;
} uh_ison_queue;

uh_ison_queue *uh_list = NULL, 
	      *ison_list = NULL;

static void make_new_uh_entry (uh_ison_queue **list, char *stuff, uh_ison_func func, char *nicklist)
{
	uh_ison_queue *ptr = *list;

	if (ptr)
	{
		while (ptr->next)
			ptr = ptr->next;
		ptr->next = (uh_ison_queue *)new_malloc(sizeof(uh_ison_queue *));
		ptr = ptr->next;
	}
	else
	{
		ptr = (uh_ison_queue *)new_malloc(sizeof(uh_ison_queue *));
		*list = ptr;
	}

	ptr->next = NULL;
	ptr->stuff = stuff;
	ptr->func = func;
	ptr->nicklist = niclist;
	return;
}

static uh_ison_queue *remove_top_entry (uh_ison_queue **list)
{
	uh_ison_queue *ptr = *list;
	if (!ptr)
		return;

	*list = ptr->next;
}

static void destroy_entry (uh_ison_queue *ptr)
{
	if (!ptr)
		return;
	if (ptr->stuff)
		new_free(&ptr->stuff);
	new_free((char **)&ptr);
}

void get_userhost (char *nicklist, uh_ison_func call_it, char *stuff)
{
	make_new_uh_entry (&uh_list, stuff, call_it, nicklist);
	send_to_server("USERHOST %s", nicklist);
}

extern void numeric_302_handler (char *form, char **ArgList)
{
	uh_ison_queue *thing, whois_stuff = NULL;

	char	*nick,
		*cnick = NULL,
		*tnick;
	char	*user,
		*cuser = (char *) 0;
	char	*host,
		*chost = (char *) 0;
	int	ishere,
		cishere = 1;
	int	isoper,
		cisoper = 0;
	int	noton,
		isuser,
		parsed;
	char	*queue_nicks;

	if (!ArgList[0])
		return;

	thing = get_top_entry (&uh_list);
	original_nicklist = thing->nicklist;
	get_new_nick = 1;

	while (original_nicklist)
	{
		if (get_new_nick)
		{
			get_new_nick = 0;

			this_nick = next_arg(ArgList[0], ArgList);
			if (this_nick)
			{
				if (!(this_user = index(this_nick, '=')))
					break;

				/* check for oper status */
				if (this_user[-1] == '*')
				{
					this_user[-1] = 0;
					this_user_isoper = 1;
				}
				else
					this_user_isoper = 0;

				/* check for here or away */
				*this_user++ = '\0';
				if (*this_user++ == '+')
					this_user_ishere = 1;
				else
					this_user_ishere = 0;

				/* check for host info */
				if (!(this_host = index(this_user, '@')))
					break;

				*this_host++ = '\0';
				parsed = 1;
			}
		}

		original_nick = next_arg(original_nicklist, &original_nicklist);
		if (!*original_nicklist)
			original_nicklist = NULL;

		if (!this_nick || my_stricmp(this_nick, original_nick))
		{
			if (this_nick)
				nick = this_nick;
			else
				nick = original_nick;
			user = host = "<UNKNOWN>";
			oper = 0;
			here = 1;
			noton = 1;
			get_new_nick = 0;
		}
		else
		{
			nick = this_nick;
			user = this_user;
			host = this_host;
			oper = this_user_isoper;
			here = this_user_ishere;
			get_new_nick = 1;
		}

		if (!isuser)
			thing->func(nick, user, host, isoper, noton, away)

		else
		{
			if (do_hook(current_numeric, "%s %s %s %s %s", nick,
			    isoper ? "+" : "-", ishere ? "+" : "-", user, host))
				put_it("%s %s is %s@%s%s%s", numeric_banner(),
					nick, user, host, isoper ?
					" (Is an IRC operator)" : empty_string,
					ishere ? empty_string : " (away)");
		}
	}

	destroy_entry(thing);
}

extern numeric_303_handler (char *from, char **ArgList)
{
	uh_ison_queue *entry = get_top_entry(&ison_list);

	/* get original list */
	/* get returned list */

	/* hook the returned list */
}

